#!/bin/sh
# /home/abacus/C2/danholav.sh - ABACUS operator interface 
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0
########################################################################
#
# BIP ABACUS 
#
# Initial version 980907
# 
# 
########################################################################

Pic copy Pic_bip-evaporat

button $w.p.ti_hem1  -bitmap @./MCH-Konsulting-small-bw-1.xbm \
  -command { change_to bip-menu }
place $w.p.ti_hem1 -x 0 -y 0 

button $w.p.ti_hem2  -bitmap @./MCH-Konsulting-small-bw-2.xbm \
  -command { change_to bip-evaporat }
place $w.p.ti_hem2 -x 48 -y 0 

button $w.p.ti_prev -bitmap @./big_left_button.xbm \
  -command { change_to bip-feedstor }
place $w.p.ti_prev -x 113 -y 0 

button $w.p.ti_next -bitmap @./big_right_button.xbm\
  -command { change_to bip-resins }
place $w.p.ti_next -x 148 -y 0

# button $w.p.ti_hem  -bitmap @./Rowan_House.xbm \
#   -command { change_to bip-menu }
# place $w.p.ti_hem -x 0 -y 35 
 
set tags 1

button $w.p.ti_tag -text "No-tags" \
  -command {
      if { $tags } {
	 Pic copy Pic_bip-evaporat-no-tag 
	 $w.p.ti_tag configure -text "tags" 
	 set tags 0
      } else {
	 Pic copy Pic_bip-evaporat
	 $w.p.ti_tag configure -text "No-tags" 
	 set tags 1
      }
    }
place $w.p.ti_tag -x 184 -y 0



############## This is the main dynamic data updating proc ##################
#
#
#

set six  15		
set spx 190		
set unx 260		
set rax 325		
set s1x 420		
set s2x 520		

proc update0 {} {
	global w lfont fg bg NODE
	global six spx unx rax s1x s2x

 	global fulltime halftime time_taken
 	
	if { [winfo viewable .] } {

	   set time_taken [ time	{
		get_values

### Agitators AG1 & AG2	
	catch { shape_2 AG1oc  213 219  [vn 10070] blob_green blob_red } ;# BIP1:AG1.FB.
	catch { if { [vn 10072] } { shape_2_flash AG1al  213 219 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 AG1ha 233 219 [vn 10071] blank hand } ;#   hand/auto

	catch { shape_2 AG2oc   435  219  [vn 10073] blob_green blob_red } ;# BIP1:AG2.FB.
	catch { if { [vn 10075] } { shape_2_flash AG2al  435 219 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 AG2ha 435 219 [vn 10074] blank hand } ;#   hand/auto

### Valves
	catch { shape_2 V14oc   117 100  [vn 10303] valve_onoff_l_open_red-hollow valve_onoff_l_close_green } ;# BIP1:V14.FB.
	catch { if { [vn 10305] } { shape_2_flash V14al   115 104 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 V14ha 152 85 [vn 10304] blank hand } ;#   hand/auto

	catch { shape_2 V13oc   24 218  [vn 10301] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# BIP1:V13.FB.
	catch { if { [vn 10302] } { shape_2_flash V13al   19 206 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
#	catch { shape_2 V13ha [vn ] blank hand } ;#   hand/auto

	catch { shape_2 V15oc   183 168  [vn 10306] valve_onoff_b_open_red-hollow valve_onoff_b_close_green } ;# BIP1:V15.FB.
	catch { if { [vn 10308] } { shape_2_flash V15al   182 171 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 V15ha  211 141 [vn 10307] blank hand } ;#   hand/auto

	catch { shape_2 V31oc   80 265  [vn 10328] valve_onoff_b_open_red-hollow valve_onoff_b_close_green } ;# BIP1:V31.FB.
	catch { if { [vn 10330] } { shape_2_flash V31al   76 270 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 V31ha  78 291 [vn 10329] blank hand } ;#   hand/auto

	catch { shape_2 V18oc   428 177  [vn 10316] valve_onoff_b_open_red-hollow valve_onoff_b_close_green } ;# BIP1:V18.FB.
	catch { if { [vn 10318] } { shape_2_flash V18al   427 180 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 V18ha  451 155 [vn 10317] blank hand } ;#   hand/auto

	catch { shape_2 V312oc   334 265  [vn 10328] valve_onoff_b_open_red-hollow valve_onoff_b_close_green } ;# BIP1:V31.FB.
	catch { if { [vn 10330] } { shape_2_flash V312al   330 270 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
	catch { shape_2 V312ha  334 291 [vn 10329] blank hand } ;#   hand/auto

	catch { shape_4 threewayV17   588 333 [vn 10312] [vn 10313] bip-three-way-1 bip-three-way-2 bip-three-way-3 alarm_blob }
	catch { if { [vn 10315] } { destroy $w.p.tithreewayV17 ; shape_2 threewayV17 588 331 $blinkon  alarm_blob alarm_blob_gray } }

### Pumps

	catch { shape_2 P1rs  292 382  [vn 10156] pump_u_green pump_u_red} ;# (BIP1:P1.FB.)
	catch { if { [vn 10161] } { shape_2_flash P1al  292 382 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP1al } }
	catch { shape_2 P1ha  312 382  [vn 10160] blank hand } ;#   hand/auto

	catch { shape_2 P9rs  520 282  [vn 10203] pump_r_green pump_r_red} ;# (BIP1:P9.FB.)
	catch { if { [vn 10205] } { shape_2_flash P9al  520 282 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP9al } }
	catch { shape_2 P9ha   540 282 [vn 10204] blank hand } ;#   hand/auto

	catch { shape_2 P2rs  531 358  [vn 10177] pump_u_green pump_u_red} ;# (BIP1:P2.FB.)
	catch { if { [vn 10182] } { shape_2_flash P2al  531 358 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP2al } }
	catch { shape_2 P2ha   551 358 [vn 10181] blank hand } ;#   hand/auto

	catch { shape_2 P8rs  316 187  [vn 10200] pump_r_green pump_r_red} ;# (BIP1:P8.FB.)
	catch { if { [vn 10202] } { shape_2_flash P8al  316 187 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP8al } }
	catch { shape_2 P8ha   336 187 [vn 10201] blank hand } ;#   hand/auto

### analog values
	catch { text_item TI8val  200 92 "%3.0f \'C" [ra 10279] }
	catch { text_item TI11val  507 208 "%3.0f \'C" [ra 10263] }
	catch { text_item TI29val  420 10 "In  %7.1f \'C" [ra 10277] }
	catch { text_item TI28val  420 20 "Out %7.1f \'C" [ra 10271] }
	catch { text_item FIC7val   120 203  "%3.0f l/h" [ra 10088] } ;# (BIP1:FIC7.MV.)
	catch { text_item FIQ7val   367 417  "%3.0f litres" [ra 10094] } ;# (BIP1:FIC7.TOTAL.)
	catch { text_item TI23val   137 364  "%3.1f C"   [ra 10264] } ;# (BIP1:TI23.MV.)
	catch { text_item LIC15val  137 346  "%3.1f %%"  [ra 10130] } ;# (BIP1:LIC15.MV.)
	catch { text_item TI26val   385 364  "%3.1f C"   [ra 10268] } ;# (BIP1:TI26.MV.)
	catch { text_item LIC19val  385 346  "%3.1f %%"  [ra 10151] } ;# (BIP1:LIC19.MV.)
	catch { text_item PIC39val  115 280  "%3.2f Bar" [ra 10211] } ;# (BIP1:PIC39.MV.)
	catch { text_item PIC41val  373 280  "%3.2f Bar" [ra 10231] } ;# (BIP1:PIC41.MV.)
	catch { text_item LIC17val  344 149  "%3.1f %%"  [ra 10136] } ;# (BIP1:LIC17.MV.)
	catch { text_item LIC18val  575 254  "%3.1f %%"  [ra 10144] } ;# (BIP1:LIC18.MV.)
	catch { text_item TIC22val  123 157  "%3.1f C"   [ra 10282] } ;# (BIP1:TIC22.MV.)
	catch { text_item PIC42val  594 228  "%3.0f mB" [ra 10240] } ;# (BIP1:PIC42.MV.)
	catch { text_item PIC40val  482 126  "%3.0f mB" [ra 10220] } ;# (BIP1:PIC40.MV.)
	catch { text_item FIQ9val   294 132  "%3.0f ltr" [ra 10084] } ;# (BIP1:FI9.TOTAL.)
	catch { text_item FIQ10val   510 236  "%3.0f ltr" [ra 10078] } ;# (BIP1:FI10.TOTAL.)
		}]
	  }

################# Here we queue up this proc again ##########################

##
	show_time $time_taken
	catch { after cancel update0 }
	after $fulltime update0
	}


set bg	#D0D0D0
set bg	grey70
set fg  MidnightBlue
set fg	yellow
set fg	darkgreen
set fg	black
set fg	darkblue
 	
set lfont {courier 10 bold}

update0
update idletasks
#								blk_acb blk_sp blk_hl blk_ll blk_ar blk_st blk_ut
 catch { $w.p.tib10099     configure -command { entry_stuff_multi_ut  8099 10099     0	   0	  0	0     0  } }
# catch { $w.p.tib10101     configure -command { entry_stuff_multi_ut  8101 10101     0	   0	  0	0     0  } }
 catch { $w.p.tib10076     configure -command { entry_stuff_multi_ut  8076 0	   0	  0	10076     10076     0  } }
 catch { $w.p.tis1b10076     configure -command { entry_stuff_multi_ut  8076 0	   0	  0	10076     10076     0  } }
 catch { $w.p.tis2b10076     configure -command { entry_stuff_multi_ut  8076 0	   0	  0	10076     10076     0  } }
 
 ######################################################## MV     SP    OP MANUAL STATE 
 catch { $w.p.tiFIC7val  configure -command { face_plate 10088 10091 10089 10586 10093 3000.0 0.0 1   "LOOP VIEW" "BIP1:FIC7."  } }
 catch { $w.p.tiTI23val  configure -command { face_plate_no_ha 10264 10265     0     0     0  100.0 0.0 0.1 "LOOP VIEW" "BIP1:TI23. "  } }
 catch { $w.p.tiTI26val  configure -command { face_plate_no_ha 10268 10269     0     0     0  100.0 0.0 0.1 "LOOP VIEW" "BIP1:TI26. "  } }

 catch { $w.p.tiLIC15val  configure -command { face_plate_no_ha 10130 10133 10131     0	 0  100.0 0.0 0.1 "LOOP VIEW" "BIP1:LIC15. "  } }
 catch { $w.p.tiLIC19val  configure -command { face_plate_no_ha 10151 10154 10152     0	 0  100.0 0.0 0.1 "LOOP VIEW" "BIP1:LIC19. "  } }

 catch { $w.p.tiPIC39val configure -command { face_plate 10211 10214 10212 10582 10216  6.0 0.0 0.01  "LOOP VIEW" "BIP1:PIC39. "  } }
 catch { $w.p.tiPIC41val configure -command { face_plate 10231 10234 10232 10584 10236  6.0 0.0 0.01  "LOOP VIEW" "BIP1:PIC41."  } }
 catch { $w.p.tiLIC17val configure -command { face_plate 10136 10140 10137 10587 10141 100.0 0.0 0.1  "LOOP VIEW" "BIP1:LIC17."  } }
 catch { $w.p.tiLIC18val configure -command { face_plate 10144 10148 10145 10588 10149 100.0 0.0 0.1  "LOOP VIEW" "BIP1:LIC18."  } }
 catch { $w.p.tiTIC22val configure -command { face_plate 10282 10285 10283 10591 10286  50.0 0.0 0.1  "LOOP VIEW" "BIP1:TIC22."  } }
 catch { $w.p.tiPIC42val configure -command { face_plate 10240 10244 10241 10585 10245 1500.0 0.0 0.1 "LOOP VIEW" "BIP1:PIC42."  } }
 catch { $w.p.tiPIC40val configure -command { face_plate 10220 10224 10221 10583 10225 1500.0 0.0 0.1 "LOOP VIEW" "BIP1:PIC40."  } }

 catch { $w.p.tiPIC39val configure -command { face_plate 10211 10214 10212 10582 10216 6.0 0.0 0.01 "LOOP VIEW" "BIP1:PIC39. STEAM STAGE 1 PRS. PIC39"  } }


 catch { $w.p.tiP1rs    configure -command { entry_pump_hand_auto_bip  10156 10599 10160 "P1" "PUMP: P1"	} }
 catch { $w.p.tiP2rs    configure -command { entry_pump_hand_auto_bip  10177 10600 10181 "P2" "PUMP: P2"	} }
 catch { $w.p.tiP8rs    configure -command { entry_pump_hand_auto_bip  10200 10615 10201 "P8" "PUMP: P8"	} }
 catch { $w.p.tiP9rs    configure -command { entry_pump_hand_auto_bip  10203 10616 10204 "P9" "PUMP: P9"	} }



######### Valves ##################

########################################################################  FB MANUAL STATE

 catch { $w.p.tiV14oc  configure -command { entry_valve_hand_auto_bip_3  10303 10631 10304 "V14" "VALVE: V14"   } }
# catch { $w.p.tiV13oc  configure -command { entry_valve_hand_auto_bip_3   "V13" "VALVE: V13"   } }
 catch { $w.p.tiV15oc  configure -command { entry_valve_hand_auto_bip_3_i  10306 10632 10307 "V15" "VALVE: V15"	} }
 catch { $w.p.tiV31oc  configure -command { entry_valve_hand_auto_bip_3  10328 10638 10329 "V31" "VALVE: V31"	} }
 catch { $w.p.tiV18oc  configure -command { entry_valve_hand_auto_bip_3_i  10316 10634 10317 "V18" "VALVE: V18"	} }
 catch { $w.p.tiV312oc configure -command { entry_valve_hand_auto_bip_3  10328 10638 10329 "V31" "VALVE: V31"	} }

#	catch { shape_4 threewayV17   588 331 [vn 10312] [vn 10313] bip-three-way-1 bip-three-way-2 bip-three-way-3 alarm_blob }
#Added 000126
 catch { $w.p.tithreewayV17  configure -command { entry_stuff_0_1 threewayV17 "Resin to Blender" 10595 " yes "   " no " } }
